@ECHO OFF
:REM
:REM  BUILD.BAT ͻ
:REM                                                                       
:REM  FreeXP "make" Batchdatei: Compiliert alle fr FreeXP relevanten      
:REM                            Programme und Ressourcen und erstellt      
:REM                            Distributions- und Source-Archivdateien    
:REM                                                                       
:REM  (c) FreeXP 2003-2024, http://www.freexp.de                           
:REM                                                                       
:REM Ķ

:REM Ŀ
:REM  Umgebungsvariablen setzen
:REM  (%BP_PATH%, %ZIP_PATH% und %ZIP_PROG% ggf. anpassen!)
:REM 
:REM Pfad zu Borland Pascal (ohne abschlieenden Backslash!)
REM SET BP_PATH=U:\BP\BIN
SET BP_PATH=C:\BP\BIN
:REM Optionen fr BP (ohne fhrendes Leerzeichen, nicht ndern!)
:REM ("-CD": DOS real mode target, "-B": Build all units)
SET BP_OPT=-CD -B
:REM Pfad zu ZIP-Programm (ohne abschlieenden Backslash!)
:REM SET ZIP_PATH=c:\git-Work\freexp\BIN\7ZIP
SET ZIP_PATH=c:\git-Work\freexp\BIN\INFOZIP
:REM Name des ZIP-Programms
:REM (wenn nicht PKZIP, verwendete Optionen auf Kompatibilitt prfen!)
:FREM SET ZIP_PROG=7Z.EXE
SET ZIP_PROG=ZIP.EXE

ECHO Ŀ
ECHO  Schritt 3: FreeXP compilieren ...                                      
ECHO 

MD XPDIR
CD XPDIR
MD DOC
CD ..
MD DISTRI
CD ..
CD ..
%BP_PATH%\BPC.EXE %BP_OPT% -EBUILD\DOS16\XPDIR UUZ
DEL BUILD\DOS16\XPDIR\*.TPU
COPY BINARIES\UKAWP.EXE BUILD\DOS16\XPDIR\
COPY BINARIES\XP_NTVDM.DLL BUILD\DOS16\XPDIR\
COPY DOC\UKAWP.TXT BUILD\DOS16\XPDIR\DOC\
COPY DOC\UUZ_ENH.TXT BUILD\DOS16\XPDIR\DOC\
COPY DOC\XP_NTVDM.TXT BUILD\DOS16\XPDIR\DOC\
CD BUILD
CD DOS16
CD XPDIR
%ZIP_PATH%\%ZIP_PROG% -r ..\DISTRI\UUZ_ENH.ZIP @..\..\ALL\UUZ.LST
CD ..


