{ --------------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.                     }
{ (c) 2000-2001 OpenXP-Team                                             }
{ (c) 2002-2024 FreeXP, http://www.freexp.de                            }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.           }
{                                                                       }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der       }
{ Datei SLIZENZ.TXT oder auf http://www.crosspoint.de/oldlicense.html   }
{                                                                       }
{ Compilerdirektiven fr CrossPoint (FreeXP)                             }
{ --------------------------------------------------------------------- }

{ Wenn gesetzt, werden erweiterte Checks in der EXE-Datei durchgefhrt
  (Rangecheck) usw.        }

{.$DEFINE Debug        }

{ Wenn gesetzt, werden in die TPU/TPP Debug Informationen gespeichert
  und es kann eine ausfhrliche Map-Datei erstellt werden. ndert den
  Code der EXE-Datei nicht
  Unter Virtual Pascal werden Informationen ber die Zeilennummern
  gespeichert, vergrert die EXE-Datei etwas.        }

{.$DEFINE DebugInfo        }

{ Wenn gesetzt, werden erweiterte Infos zu FIDO-Nodelisten ausgegeben
  u.a. $USERIDX.TXT im Verz. \FIDO        }

{.$DEFINE FIDOTST        }

{ Keine Assembler-Routine verwenden. Ein Gegenpart in Pascal mu
  existieren        }
{.$DEFINE NOASM        }

{ Ist definiert, wenn Beta-Informationen anzeigt werden sollen        }
{.$DEFINE Beta        }

{ Ist in Snapshot-Versionen definiert        }
{.$DEFINE Snapshot       }

{ Ist definiert, wenn ein getrenntes Overlay erstellt werden soll        }
{$DEFINE USEOVR       }

{ Wenn dieser Schalter definiert ist, wird eine Version mit CAPI-
  Unterstzung compiliert        }
{.$DEFINE CAPI        }

{ --- ab hier sind keine nderungen ntig ---        }

{ Grundstzlich mu ersteinmal in jeder Version die Registrierungs-
  prozedur enthalten sein        }
{$DEFINE NeedReg        }

{$IFDEF VER70        }
  {$DEFINE BP        }           { 16 Bit Borland Pascal 7 oder 8 (Delphi 1)        }
  {$IFDEF DPMI        }
    {$DEFINE DPMI16        }
  {$ENDIF        }
{$ENDIF        }

{$IFDEF VER80        }
  {$DEFINE BP        }           { 16 Bit Borland Pascal 7 oder 8 (Delphi 1)        }
  {$IFDEF DPMI        }
    {$DEFINE DPMI16        }
  {$ENDIF        }
{$ENDIF        }

{$IFDEF BP        }              { Nur fr Borland Pascal 7 und 8        }
  {$A+,B-,D-,E+,F-,I-,G+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-       }
{$ENDIF        }

{$IFDEF DebugInfo        }
  {$D+,L+,Y+       }
{$ENDIF        }

{$IFDEF Debug        }
  {$R+,S+,Q+       }
{$ENDIF        }

